// A simple button class with simple button functions

class Button
{
  // variables for the position, radius, colors and type
 int xPos = width/2;
 int yPos = 700;
 int radius = 50;
 int radius2 = 50;
 int currentColor;
 int offColor = #999999;
 int hoverColor = #cccccc;
 int onColor = #ffffff;
 int type;
 boolean status;
 
 // Constructor to customize the button(s) when initialized
 Button(int _type, int _xPos, int _yPos, int _radius, int _radius2, int _offColor, int _hoverColor, int _onColor)
 {
   //gameWorld = _gameWorld;
   type = _type;
   xPos = _xPos;
   yPos = _yPos;
   radius = _radius;
   radius2 = _radius2;
   offColor = _offColor;
   hoverColor = _hoverColor;
   onColor = _onColor;   
 }
 
 // Checking what type of button it is / needs to be. 
 // Type 0 means it's a circle button, type 1 is a rectangle button. 
 // The variables get used here for position and size.
 void draw()
 {
   if(type == 0)
   {
     overCircle();
     fill(currentColor);
     circle(xPos, yPos, radius);
   }  
   if(type == 1)
   {
     overRect();
     rectMode(CENTER);
     fill(currentColor);
     rect(xPos, yPos, radius, radius2);
   }
   
   if(status == true)
   {
     currentColor = onColor;
   }
   else
   {
     currentColor = offColor;
   }
     
 }
 
 
 // checking whether the mouse is hovering over a circle button.
 // used for highlight coloring, if mouse is hovering over it.
 // else the offColor is used.
 boolean overCircle() 
 {
   float disX = xPos - mouseX;
   float disY = yPos - mouseY;
   if(sqrt(sq(disX) + sq(disY)) < radius/2 ) 
   {
     if(status == false)
     {
       currentColor = hoverColor;
       return true;       
     }
     else
     {
       currentColor = offColor + #555555;
       return true;
     }
   } 
   return false;
 }
 
 // same as above EXCEPT this method checks if mouse is hovering over a rectangle
 // other than that the code does the same.
 boolean overRect() 
 {
   if(mouseX >= xPos && mouseY >= yPos && mouseX <= xPos + radius && mouseY <= yPos + radius)
   {
     if(status == false)
     {
       currentColor = hoverColor;
       return true;
     }
     else
     {
       currentColor = onColor;
       return true;
     }
   } 
   else 
   {
     return false;
   }
 }
 
 // handling the mouse clicks. 
 // if clicked while the mousepointer is over a button the button status is set to true (active)
 // color also gets set to the button active color.
 void mouseClicked()
 {
   if(overCircle() == true || overRect() == true)
   {
     if(status == false)
     {
       // println("clickOn");
       status = true;
       currentColor = onColor;
     }
     else
     {
       // println("clickOff");
       status = false;
       currentColor = offColor;
     }  
   }
   return;
 }
}
