// Counter objects display the current score in the game 
// they also indicate which player is which by responding to the mic inputs 

class Counter {

  GameWorld gameWorld;

  float xPos, yPos;
  PImage img = new PImage();
  int num_pink, num_blue;
  PFont f;
  int resizeCounter = 0;
  boolean pink;

  public Counter(GameWorld _gameWorld, boolean _pink)
  {
    gameWorld = _gameWorld;
    pink = _pink;
  }

  void saveNum(int c)           // gets called in GameWorld, each time the players collect a flower
  {
    if (pink) 
    {
      num_pink = c;
      println("saveNum: "+num_pink);
    } else 
    {
      num_blue = c;
    }
  }
    
  void display(float y) {       // since the counters are always supposed to remain in the same spot despite the translation of the gameworld they need the input of the scroll factor

    yPos = y;                       
    if (pink)                   // drawing of the pink cloud 
    {
      xPos = width - 140;
      noStroke();
      fill(186, 155, 201);
      
      // drawing the clouds 
      // three circles for the "body" of each cloud that change size according to the intensity of the player blowing to get feedback
      
      circle(xPos, yPos, 90 + (2*(int(gameWorld.accum1))));
      circle(xPos - 40 - (1*(int(gameWorld.accum1))), yPos + 10, 50 + (1*(int(gameWorld.accum1))));
      circle(xPos + 40 + (1*(int(gameWorld.accum1))), yPos + 5, 60 + (2.5*(int(gameWorld.accum1))));
      
      // eyes that change size according to the intensity of the player blowing to get feedback
      
      fill(#eeeeee);
      ellipseMode(CENTER);
      ellipse(xPos - 20 - (int(gameWorld.accum1) / 3), yPos, 15 + (int(gameWorld.accum1) / 1.5), 20 + (int(gameWorld.accum1) / 1.5));
      ellipse(xPos + 20 + (int(gameWorld.accum1) / 3), yPos, 15 + (int(gameWorld.accum1) / 1.5), 20 + (int(gameWorld.accum1) / 1.5));

      f = createFont("Arial", 28, true);
      textFont(f);

      fill(84, 53, 102);
      text (this.num_pink, xPos -11, yPos);
      
    } else                    // drawing the blue cloud
    {
      xPos = 140;
      noStroke();
      fill(101, 200, 208);
      circle(xPos, yPos, 90 + (2*(int(gameWorld.accum2))));
      circle(xPos + 40 + (1*(int(gameWorld.accum2))), yPos + 10, 50 + (1*(int(gameWorld.accum2))));
      circle(xPos - 40 - (1*(int(gameWorld.accum2))), yPos + 5, 60 + (2.5*(int(gameWorld.accum2))));

      //eyes
      fill(#eeeeee);
      ellipseMode(CENTER);
      ellipse(xPos - 20 - (int(gameWorld.accum2) / 3), yPos, 15 + (int(gameWorld.accum2) / 1.5), 20 + (int(gameWorld.accum2) / 1.5));
      ellipse(xPos + 20 + (int(gameWorld.accum2) / 3), yPos, 15 + (int(gameWorld.accum2) / 1.5), 20 + (int(gameWorld.accum2) / 1.5));

      f = createFont("Arial", 28, true);
      textFont(f);
      fill(44, 90, 90);

      text (this.num_blue, xPos -11, yPos);
    }
  }
}
