// class handling the events when the game ended

class GameEndsMode extends GameMode 
{
  // setting up the needed variables for the title, background color, score and to store the microphone lines for the next spidegame mode
  String title;
  color backgroundColor;
  TargetDataLine lineP1, lineP2;
  int score;

  // constructor to receive the variables mentioned above and to store them
  GameEndsMode(String _title, color _backgroundColor, TargetDataLine _lineP1, TargetDataLine _lineP2, int _score)
  {
    title = _title;
    backgroundColor = _backgroundColor;
    lineP1 = _lineP1;
    lineP2 = _lineP2;
    score = _score;
  }

  // showing the different player win or draw outcomes by checking the title that was given on game over
  void draw()
  {
    pushStyle();
    fill(#ffffff);
    background(backgroundColor);
    textAlign(CENTER, CENTER);
    textSize(64);
    text(title, width/2, height/2);
    textSize(32);
    if (title == "You win!") 
    {
      if (score == 1)  // means the blue player has more points than the pink player
      {
        textSize(32);
        text("Blue wins!", width/2, height/1.5);
      }
      if (score == 2) // means the pink player has more points than the blue player
      {
        textSize(32);
        text("Pink wins!", width/2, height/1.5);
      }
      if (score == 0) // both players have the same amount of points
      {
        textSize(32);
        text("That's a draw!", width/2, height/1.5);
      }
      text("Press any key to play again.", width/2, height*3/4);
      popStyle();
    }
  }

  // handling the mouse clicks or key presses to start another round of spidey game
  void mouseClicked()
  {
    gameMode = new SpideyGame(lineP1, lineP2);
  }
  void keyPressed()
  {
    gameMode = new SpideyGame(lineP1, lineP2);
  }
}
