// Importing the Java Sound Libraries 
import javax.sound.sampled.*;
import java.io.ByteArrayOutputStream;
import java.lang.Object.*;

GameMode gameMode;

// Setting up the framerate & the game mode
void setup () 
{
  frameRate(60); 
  gameMode = new MenuMode();
  gameMode.setup();
}

void settings()
{
  size(1000, 1000, P2D);
}

// fills a PImage Array with the right frames to display a sprite 
PImage[] loadFrames(String name, int numFrames, int w, int h) 
{ 
  PImage img = loadImage(name + ".png");           // loads the corresponding image according to String name
  PImage[] frames = new PImage[numFrames];         // creates PImage array with the length numFrames 

  for (int i = 0; i < numFrames; i++)            
  {
    //grabs the area of the image with the width and height and saves it as one frame until the array is full
    frames[i] = img.get(i*(img.width / numFrames), 0, img.width/numFrames, img.height); 
    frames[i].resize(w, h);
  }
  return frames;
}

void draw() 
{
  gameMode.draw();
}

void mouseClicked()
{
  gameMode.mouseClicked();
}

void keyPressed()
{
  gameMode.keyPressed();
}

void mouseReleased() 
{
  gameMode.mouseReleased();
}

void keyReleased()
{
  gameMode.keyReleased();
}
